<template>
 <div >
    <main class="cardUsers">
        <div class="user">
            <div>
                <p 
                    contenteditable="true" 
                    style="font-weight:bold;width:50%" 
                    @input="eventoInput(allUser.email)" 
                    :id="allUser.email">{{allUser.displayName}}</p>
                <p>{{allUser.email}}</p>
            </div>
           <div class="icon-top-right">
               <el-button @click="guardarUsuario()" :loading="loading">GUARDAR</el-button>
           </div>
        </div>
        <form>
            <div class="form-add-route">
                <el-input type="text"  placeholder="Nombre de la ruta" v-model="url"></el-input>      
                <el-input type="text"  placeholder="Título de la ruta" v-model="title"></el-input>  
                <el-button class="btn_add_routes" @click="addRoutes">Agregar</el-button>
            </div>
        </form>
        <el-tabs v-model="activeName" @tab-click="handleClick" type="card" class="listRoutes">
            <el-tab-pane label="Rutas" name="first">
                <cardAddRoutes 
                    v-for="(item,index) in allUser.allowedRoutes" 
                    :key="index" 
                    @removeRoutes='eliminarRuta(index,"ruta")'
                    @removeRouteChildren='eliminarRutaChildren($event,index,"ruta")'
                    :route="item">
                </cardAddRoutes>
            </el-tab-pane>
            <el-tab-pane label="Subrutas" name="second">
                <cardAddRoutes 
                    v-for="(item,index) in allUser.allowedSubRoutes" 
                    :key="index" 
                    @removeRoutes='eliminarRuta(index,"subruta")'
                    @removeRouteChildren='eliminarRutaChildren($event,index,"subruta")'
                    :route="item">
                </cardAddRoutes>
            </el-tab-pane>
        </el-tabs>
    </main>
  </div>
</template>

<style>
.form-add-route{
    margin-top: 1rem;
    display: flex;
    justify-content: space-between;
}
    
 .cardUsers{
     width: 50%;
     margin: 8rem auto -6rem;
     border-radius: 4px;
     border: 1px solid #d7d7d7;
     box-shadow: 5px 5px 5px 0px rgba(121, 0.16, 110, 0.16);
     padding: 2em;

 }

 .user{
     height: auto;
     border-bottom: 5px solid;
     border-color: #ff5000;
     padding: 1em;
 }

.title_rutas{
    margin: 1em;
    
}

.btn_add_routes{
    display:block;
    background-color: #2196F3; 
    color: #fff;
    border: none;
    padding: 8px 16px;
    cursor: pointer;
    margin-left: 3.4em;
    border-radius: 5px;
}


.input_routes{
    width: 80%;
    border: 1px solid #ccc;
    padding: 8px;
    display: block;
    border-radius: 5px;
    margin: 2em auto 1em;
}
.listRoutes{
    margin-top: 2em;
}
.icon-top-right{
    position: relative;
    top:-2.5rem;
    right: -25rem;
    display: inline-block;   
}

</style>
<script>
 import cardAddRoutes from '@/components/cardAddRoutes'
 import cardSubRoutes from '@/components/cardSubRoutes'
 import {HTTP} from '@/main.js'


 export default {
  components: {cardAddRoutes,cardSubRoutes},
  name: 'cardUsersPermissions',
  
  data() {
      return{
          i: -1,
          url: '',
          title:'',
          activeName: 'first',
          loading:false,
    }
  },
    props:{
        allUser: {
            type: Object
        }
    },
  methods: {
      eliminarRutaChildren(e,index,type){
          if(type=='ruta'){this.allUser.allowedRoutes[index].children.splice(e,1)}
          else{this.allUser.allowedSubRoutes[index].children.splice(e,1)}
      },
      eliminarRuta(index,tipo){
          if(tipo=='ruta'){this.allUser.allowedRoutes.splice(index,1)}
          else{this.allUser.allowedSubRoutes.splice(index,1)}
      },
      guardarUsuario(){
          this.loading = true;
          HTTP.patch('/users/' + this.allUser._id,{user:this.allUser})
          .then(()=>this.loading=false)
          .catch(console.error)
      },
      eventoInput(id){
        let element = document.getElementById(id).textContent
        this.allUser.displayName = element;
      },
      actualizarRoutes(){
          if(this.i != -1){
              console.log({usr:this.allUser})
              HTTP({
                  method: "PATCH",
                  url: `/users/${this.allUser._id}`,
                  data: this.allUser
              })
                .then(res => {
                    console.log("modificandooo", res)
                    this.$emit("listar")
                })
          }
      },
      
      addRoutes(){
          if(this.url!='' && this.url.substring(0,1)=='/' && this.title!=''){
              let obj = {
                  title:this.title,
                  url:this.url,
                  children:[]
              }
              this.allUser.allowedRoutes.push(obj)            
          }
          this.url='';
          this.title=''        
      },

       updateRoutes(index){
        this.url = this.allUser.allowedRoutes[index].url;
        this.i = index;
        },

        updateSubRoutes(index){
            this.url = this.allUser.allowedSubRoutes[index].url;
            this.i = index;
        },

        deleteRoutes(index){
            let routes = this.allUser.allowedRoutes.indexOf(index)
            this.allUser.allowedRoutes.splice(index,1)
        },

        deleteSubRoutes(index){
            let routes = this.allUser.allowedSubRoutes.indexOf(index)
            this.allUser.allowedSubRoutes.splice(index,1);
        },

        handleClick(tab, event) {
            console.log(tab, event);
      }
  }
}
</script>
